VST 3 Examples VST 3.6.11 SDK for developing VST Plug-in

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Macros Groups Pages
Public Member Functions | Static Public Attributes | Protected Types | Protected Member Functions | Protected Attributes | List of all members
HostCheckerController Class Reference

`#include <hostcheckercontroller.h>`

Inheritance diagram for HostCheckerController:

## Public Member Functions
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
tresult | terminate () SMTG_OVERRIDE
tresult | setComponentState (IBStream *state) SMTG_OVERRIDE
tresult | getUnitByBus (MediaType type, BusDirection dir, int32 busIndex, int32 channel, UnitID &unitId) SMTG_OVERRIDE
tresult | setComponentHandler (IComponentHandler *handler) SMTG_OVERRIDE
int32 | getUnitCount () SMTG_OVERRIDE
tresult | setParamNormalized (ParamID tag, ParamValue value) SMTG_OVERRIDE
tresult | beginEdit (ParamID tag) SMTG_OVERRIDE
tresult | endEdit (ParamID tag) SMTG_OVERRIDE
IPlugView * | createView (FIDString name) SMTG_OVERRIDE
tresult | notify (IMessage *message) SMTG_OVERRIDE
tresult | connect (IConnectionPoint *other) SMTG_OVERRIDE
VSTGUI::CView * | createCustomView (VSTGUI::UTF8StringPtr name, const VSTGUI::UIAttributes &attributes, const VSTGUI::IUIDescription *description, VSTGUI::VST3Editor *editor) SMTG_OVERRIDE
tresult | setKnobMode (KnobMode mode) SMTG_OVERRIDE
tresult | openHelp (TBool) SMTG_OVERRIDE
tresult | openAboutBox (TBool) SMTG_OVERRIDE
tresult | setState (IBStream *state) SMTG_OVERRIDE
tresult | getState (IBStream *state) SMTG_OVERRIDE
tresult | setChannelContextInfos (IAttributeList *list) SMTG_OVERRIDE
tresult | getXmlRepresentationStream (RepresentationInfo &info, IBStream *stream) SMTG_OVERRIDE
tresult | getMidiControllerAssignment (int32 busIndex, int16 channel, CtrlNumber midiControllerNumber, ParamID &id) SMTG_OVERRIDE
int32 | getNoteExpressionCount (int32 busIndex, int16 channel) SMTG_OVERRIDE
tresult | getNoteExpressionInfo (int32 busIndex, int16 channel, int32 noteExpressionIndex, NoteExpressionTypeInfo &info) SMTG_OVERRIDE
tresult | getNoteExpressionStringByValue (int32 busIndex, int16 channel, NoteExpressionTypeID id, NoteExpressionValue valueNormalized, String128 string) SMTG_OVERRIDE
tresult | getNoteExpressionValueByString (int32 busIndex, int16 channel, NoteExpressionTypeID id, const TChar *string, NoteExpressionValue &valueNormalized) SMTG_OVERRIDE
tresult | getPhysicalUIMapping (int32 busIndex, int16 channel, PhysicalUIMapList &list) SMTG_OVERRIDE
void | editorAttached (EditorView *editor) SMTG_OVERRIDE
void | editorRemoved (EditorView *editor) SMTG_OVERRIDE
void | editorDestroyed (EditorView *editor) SMTG_OVERRIDE
IController * | createSubController (UTF8StringPtr name, const IUIDescription *description, VST3Editor *editor) override
DEFINE_INTERFACES | DEF_INTERFACE (IMidiMapping) DEF_INTERFACE(IXmlRepresentationController) DEF_INTERFACE(ChannelContext
void | addFeatureLog (int32 iD)
bool | getSavedSize (ViewRect &size)
Public Member Functions inherited from EditControllerEx1
| EditControllerEx1 ()
virtual | ~EditControllerEx1 ()
bool | addUnit (Unit *unit)
bool | addProgramList (ProgramList *list)
ProgramList * | getProgramList (ProgramListID listId) const
tresult | notifyProgramListChange (ProgramListID listId, int32 programIndex=kAllProgramInvalid)
tresult | getUnitInfo (int32 unitIndex, UnitInfo &info) SMTG_OVERRIDE
int32 | getProgramListCount () SMTG_OVERRIDE
tresult | getProgramListInfo (int32 listIndex, ProgramListInfo &info) SMTG_OVERRIDE
tresult | getProgramName (ProgramListID listId, int32 programIndex, String128 name) SMTG_OVERRIDE
tresult | getProgramInfo (ProgramListID listId, int32 programIndex, CString attributeId, String128 attributeValue) SMTG_OVERRIDE
tresult | hasProgramPitchNames (ProgramListID listId, int32 programIndex) SMTG_OVERRIDE
tresult | getProgramPitchName (ProgramListID listId, int32 programIndex, int16 midiPitch, String128 name) SMTG_OVERRIDE
virtual tresult | setProgramName (ProgramListID listId, int32 programIndex, const String128 name)
UnitID | getSelectedUnit () SMTG_OVERRIDE
tresult | selectUnit (UnitID unitId) SMTG_OVERRIDE
tresult | setUnitProgramData (int32, int32, IBStream *) SMTG_OVERRIDE
virtual tresult | notifyUnitSelection ()
void | update (FUnknown *changedUnknown, int32 message) SMTG_OVERRIDE
Public Member Functions inherited from EditController
| EditController ()
int32 | getParameterCount () SMTG_OVERRIDE
tresult | getParameterInfo (int32 paramIndex, ParameterInfo &info) SMTG_OVERRIDE
tresult | getParamStringByValue (ParamID tag, ParamValue valueNormalized, String128 string) SMTG_OVERRIDE
tresult | getParamValueByString (ParamID tag, TChar *string, ParamValue &valueNormalized) SMTG_OVERRIDE
ParamValue | normalizedParamToPlain (ParamID tag, ParamValue valueNormalized) SMTG_OVERRIDE
ParamValue | plainParamToNormalized (ParamID tag, ParamValue plainValue) SMTG_OVERRIDE
ParamValue | getParamNormalized (ParamID tag) SMTG_OVERRIDE
virtual tresult | performEdit (ParamID tag, ParamValue valueNormalized)
virtual tresult | startGroupEdit ()
virtual tresult | finishGroupEdit ()
virtual Parameter * | getParameterObject (ParamID tag)
virtual tresult | getParameterInfoByTag (ParamID tag, ParameterInfo &info)
virtual tresult | setDirty (TBool state)
virtual tresult | requestOpenEditor (FIDString name=ViewType::kEditor)
IComponentHandler * | getComponentHandler () const
Public Member Functions inherited from FUnknown
virtual tresult | queryInterface (const TUID _iid, void **obj)=0
virtual uint32 | addRef ()=0
virtual uint32 | release ()=0
Public Member Functions inherited from IConnectionPoint
virtual tresult | disconnect (IConnectionPoint *other)=0

## Static Public Attributes
static FUID | cid
Static Public Attributes inherited from EditController
static KnobMode | hostKnobMode
Static Public Attributes inherited from IPluginBase
static const FUID | iid
Static Public Attributes inherited from FUnknown
static const FUID | iid
Static Public Attributes inherited from IConnectionPoint
static const FUID | iid
Static Public Attributes inherited from IEditController
static const FUID | iid
Static Public Attributes inherited from IEditController2
static const FUID | iid
Static Public Attributes inherited from IUnitInfo
static const FUID | iid
Static Public Attributes inherited from IInfoListener
static const FUID | iid
Static Public Attributes inherited from IXmlRepresentationController
static const FUID | iid
Static Public Attributes inherited from IMidiMapping
static const FUID | iid
Static Public Attributes inherited from INoteExpressionController
static const FUID | iid
Static Public Attributes inherited from INoteExpressionPhysicalUIMapping
static const FUID | iid

## Protected Types
using | EditorVector = std::vector< Steinberg::Vst::EditorView * >
using | EditorMap = std::map< Steinberg::Vst::EditorView *, EditorSizeController * >

## Protected Member Functions
void | extractCurrentInfo (EditorView *editor)

## Protected Attributes
SharedPointer< CDataBrowser > | mDataBrowser
SharedPointer < EventLogDataBrowserSource > | mDataSource
bool | mLatencyInEdit = false
ParamValue | mWantedLatency = 0.0
EditorVector | editors
EditorMap | editorsSubCtlerMap
uint32 | width = 0
uint32 | height = 0
double | sizeFactor = 0

## Additional Inherited Members
Public Types inherited from EditControllerEx1
typedef (EditControllerEx1, EditController) DEFINE_INTERFACES DEF_INTERFACE(IUnitInfo) END_DEFINE_INTERFACES(EditController) REFCOUNT_METHODS(EditController) protected std::map < ProgramListID, ProgramListVector::size_type > | ProgramIndexMap
typedef std::vector< IPtr< Unit >> | UnitVector
Static Public Member Functions inherited from EditController
static KnobMode | getHostKnobMode ()
Public Attributes inherited from EditControllerEx1
UnitVector | units
ProgramListVector | programLists
ProgramIndexMap | programIndexMap
UnitID | selectedUnit
Public Attributes inherited from EditController
OBJ_METHODS(EditController, ComponentBase) DEFINE_INTERFACES DEF_INTERFACE(IEditController) DEF_INTERFACE(IEditController2) END_DEFINE_INTERFACES(ComponentBase) REFCOUNT_METHODS(ComponentBase) protected IComponentHandler2 * | componentHandler2
ParameterContainer | parameters

## Member Typedef Documentation

using EditorVector = std::vector<Steinberg::Vst::EditorView*>
| protected

using EditorMap = std::map<Steinberg::Vst::EditorView*, EditorSizeController*>
| protected

## Member Function Documentation

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Reimplemented from EditController.

tresult terminate | ( |  | ) |
| virtual

Reimplemented from EditController.

tresult setComponentState | ( | IBStream * | state | ) |
| virtual

Reimplemented from EditController.

tresult getUnitByBus | ( | MediaType | type,
|  | BusDirection | dir,
|  | int32 | busIndex,
|  | int32 | channel,
|  | UnitID & | unitId
| ) |  |
| virtual

Reimplemented from EditControllerEx1.

tresult setComponentHandler | ( | IComponentHandler * | handler | ) |
| virtual

Reimplemented from EditController.

int32 getUnitCount | ( |  | ) |
| virtual

Reimplemented from EditControllerEx1.

tresult setParamNormalized | ( | ParamID | tag,
|  | ParamValue | value
| ) |  |
| virtual

Reimplemented from EditController.

tresult beginEdit | ( | ParamID | tag | ) |
| virtual

Reimplemented from EditController.

tresult endEdit | ( | ParamID | tag | ) |
| virtual

Reimplemented from EditController.

IPlugView * createView | ( | FIDString | name | ) |
| virtual

Reimplemented from EditController.

tresult notify | ( | IMessage * | message | ) |
| virtual

Implements IConnectionPoint.

tresult connect | ( | IConnectionPoint * | other | ) |
| virtual

Implements IConnectionPoint.

CView * createCustomView | ( | VSTGUI::UTF8StringPtr | name,
|  | const VSTGUI::UIAttributes & | attributes,
|  | const VSTGUI::IUIDescription * | description,
|  | VSTGUI::VST3Editor * | editor
| ) |  |

tresult setKnobMode | ( | KnobMode | mode | ) |
| virtual

Reimplemented from EditController.

tresult openHelp | ( | TBool | onlyCheck | ) |
| virtual

Reimplemented from EditController.

tresult openAboutBox | ( | TBool | onlyCheck | ) |
| virtual

Reimplemented from EditController.

tresult setState | ( | IBStream * | state | ) |
| virtual

Reimplemented from EditController.

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from EditController.

tresult setChannelContextInfos | ( | IAttributeList * | list | ) |
| virtual

Implements IInfoListener.

tresult getXmlRepresentationStream | ( | RepresentationInfo & | info,
|  | IBStream * | stream
| ) |  |
| virtual

Implements IXmlRepresentationController.

tresult getMidiControllerAssignment | ( | int32 | busIndex,
|  | int16 | channel,
|  | CtrlNumber | midiControllerNumber,
|  | ParamID & | id
| ) |  |
| virtual

Implements IMidiMapping.

int32 getNoteExpressionCount | ( | int32 | busIndex,
|  | int16 | channel
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionInfo | ( | int32 | busIndex,
|  | int16 | channel,
|  | int32 | noteExpressionIndex,
|  | NoteExpressionTypeInfo & | info
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionStringByValue | ( | int32 | busIndex,
|  | int16 | channel,
|  | NoteExpressionTypeID | id,
|  | NoteExpressionValue | valueNormalized,
|  | String128 | string
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getNoteExpressionValueByString | ( | int32 | busIndex,
|  | int16 | channel,
|  | NoteExpressionTypeID | id,
|  | const TChar * | string,
|  | NoteExpressionValue & | valueNormalized
| ) |  |
| virtual

Implements INoteExpressionController.

tresult getPhysicalUIMapping | ( | int32 | busIndex,
|  | int16 | channel,
|  | PhysicalUIMapList & | list
| ) |  |
| virtual

Implements INoteExpressionPhysicalUIMapping.

void editorAttached | ( | EditorView * | editor | ) |
| virtual

Reimplemented from EditController.

void editorRemoved | ( | EditorView * | editor | ) |
| virtual

Reimplemented from EditController.

void editorDestroyed | ( | EditorView * | editor | ) |
| virtual

Reimplemented from EditController.

VSTGUI::IController * createSubController | ( | UTF8StringPtr | name,
|  | const IUIDescription * | description,
|  | VST3Editor * | editor
| ) |  |
| override

DEFINE_INTERFACES DEF_INTERFACE | ( | IMidiMapping |  | ) |
| inline

void addFeatureLog | ( | int32 | iD | ) |

bool getSavedSize | ( | ViewRect & | size | ) |
| inline

void extractCurrentInfo | ( | EditorView * | editor | ) |
| protected

## Member Data Documentation

FUID cid
| static

SharedPointer<CDataBrowser> mDataBrowser
| protected

SharedPointer<EventLogDataBrowserSource> mDataSource
| protected

bool mLatencyInEdit = false
| protected

ParamValue mWantedLatency = 0.0
| protected

EditorVector editors
| protected

EditorMap editorsSubCtlerMap
| protected

uint32 width = 0
| protected

uint32 height = 0
| protected

double sizeFactor = 0
| protected

Empty

Copyright ©2018 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.